/*
 * Copyright (c) 2015, University of Kaiserslautern
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * 3. Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER
 * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Authors:
 *    Janik Schlemminger
 *    Robert Gernhardt
 *    Matthias Jung
 *    Felipe S. Prado
 */

#include "PowerDownManagerTimeout.h"
#include "../ControllerCore.h"
#include "../../../common/Utils.h"
#include "../../../common/DebugManager.h"
#include "../TimingCalculation.h"

using namespace tlm;

PowerDownManagerTimeout::PowerDownManagerTimeout(sc_module_name name,
                                                 ControllerCore &controllerCore):
    PowerDownManager(name, controllerCore)
{
    //controllerCore.controller.send(PDNTrigger, Configuration::getInstance().getPowerDownTimeout(), powerDownPayloads[Bank(0)]);
}

PowerDownManagerTimeout::~PowerDownManagerTimeout()
{
    // TODO Auto-generated destructor stub
}

void PowerDownManagerTimeout::sleep(Bank /*bank*/, sc_time time)
{
    bool timeoutTest;
    if (!isAwakeForRefresh()) {
        sc_time lastReadScheduled;
        sc_time lastWriteScheduled;
        if (Configuration::getInstance().OpenPagePolicy) {
            lastReadScheduled = controllerCore.state->getLastCommand(
                                    Command::Read).getEnd();
            lastWriteScheduled = controllerCore.state->getLastCommand(
                                     Command::Write).getEnd();
        } else {
            lastReadScheduled = controllerCore.state->getLastCommand(
                                    Command::ReadA).getEnd();
            lastWriteScheduled = controllerCore.state->getLastCommand(
                                     Command::WriteA).getEnd();
        }
        sc_time lastScheduledCommand = max(lastReadScheduled, lastWriteScheduled);
        timeoutTest = (time - lastScheduledCommand) >=
                      Configuration::getInstance().getPowerDownTimeout();
    } else {
        timeoutTest = true;
    }

    //test_awakeForRefresh = false;

    if ( canSleep() && !isInPowerDown() && timeoutTest) {

        PowerDownState newState;
        if (Configuration::getInstance().PowerDownMode == EPowerDownMode::TimeoutPDN) {
            newState = controllerCore.state->rowBufferStates->allRowBuffersAreClosed() ?
                       PowerDownState::PDNPrecharge : PowerDownState::PDNActive;
        } else { // PowerDownMode == TimeoutSREF
            if (!controllerCore.state->rowBufferStates->allRowBuffersAreClosed()) {
                ScheduledCommand prechargeAllMaster(Command::PrechargeAll, time,
                                                    getExecutionTime(Command::PrechargeAll, powerDownPayloads[Bank(0)]),
                                                    DramExtension::getExtension(powerDownPayloads[Bank(0)]));

                controllerCore.getCommandChecker(
                    Command::PrechargeAll).delayToSatisfyConstraints(prechargeAllMaster);

                if (controllerCore.refreshManager->hasCollision(prechargeAllMaster)) {
                    return;
                } else {
                    for (size_t i = 1; i < controllerCore.getBanks().size(); i++) {
                        ScheduledCommand prechargeAll(Command::PrechargeAll,
                                                      prechargeAllMaster.getStart(), prechargeAllMaster.getExecutionTime(),
                                                      powerDownPayloads[Bank(i)]);
                        controllerCore.state->change(prechargeAll);
                    }
                    controllerCore.state->change(prechargeAllMaster);
                    controllerCore.controller.send(prechargeAllMaster, powerDownPayloads[Bank(0)]);
                }

            }

            newState = PowerDownState::PDNSelfRefresh;
        }

        Command cmd = IPowerDownManager::getSleepCommand(newState);
        ScheduledCommand pdn(cmd, time, getMinExecutionTimeForPowerDownCmd(cmd),
                             DramExtension::getExtension(powerDownPayloads[Bank(0)]));

        controllerCore.getCommandChecker(cmd).delayToSatisfyConstraints(pdn);

        if (controllerCore.refreshManager->hasCollision(pdn)) {
            return;
        } else {
            setPowerDownState(newState);
            sendPowerDownPayload(pdn);
        }
    }
}

void PowerDownManagerTimeout::triggerSleep(Bank /*bank*/, sc_time time)
{
    if (canSleep() && !isInPowerDown()) {
        controllerCore.controller.send(PDNTrigger,
                                       time + controllerCore.config.getPowerDownTimeout(), powerDownPayloads[Bank(0)]);
    }
}

